{ kontroly seznamu elements a Owners v TEntity !!!!!!!!! }
unit Elements;
{
[Unit_Description]
Description=Tdy zkladnch objekt ORBISu - Elementy a Entity
Admin=Petr
TechTopic=Elements
Topic=System
Version=1.0
}
{
*********************************************************************
*                                                                   *
*  ORBIS ... Tdy zkladnch objekt                               *
*                                                                   *
*                       Topol Pro 1996                             *
*********************************************************************
}
interface

uses
//   M_Orbis,
   Classes,
   FMX.Messages;


const
   { obecn konstanty }
   { **************** }
   c_NameOfElement = 'Element';
   c_NameOfEntity  = 'Entity';
   MaxListCapacity = 1000; { max count of an one list members }

   { Status Toolu }
   { ************ }
   st_Focused = 1;

   { mono pouvat pro orbisovskou zprvu .. ruen dat }
   KillIt   = true;
   DontKill = false;

  { Command Line }
   ce_FindElementByName  = 'FINDELEMENTBYNAME';
   ce_FindElementByClass = 'FINDELEMENTBYCLASS';
   ce_Element            = 'ELEMENT';
   ce_List               = 'LIST';
   ce_CreateElement      = 'CREATEELEMENT';
   ce_Free               = 'FREE';
   ce_FreeAll            = 'FREEALL';
   ce_AddElement         = 'ADDELEMENT';
   ce_FindOwnerByClass   = 'FINDOWNERBYCLASS';
   ce_FindOwnerByName    = 'FINDOWNERBYNAME';


type

   TElementID   = longInt;
//   TName        = String[20];
   TInformation = longInt;  { variace na tma TMsg }


//   PListArray = ^TListArray;
//   TListArray = array[0..MaxListSize - 1] of TList;

{ procedura a funkce pro hromadn operace superlistu }
{
TSL_Procedure = procedure(var Item: pointer);
TSL_Function  = function(var Item: pointer): boolean;
}


(*
TSuperList = class
  private
    FList:      PListArray;
    FCount:     longInt;
    FCapacity:  integer;
    FListCount: integer;
  protected
    function   AddList: integer;
    procedure  Error; virtual;
    function   Get(Index: longint): Pointer;
    procedure  Grow; virtual;
    procedure  Put(Index: longint; Item: Pointer);
    procedure  RemoveLastList;
    procedure  SetCapacity(NewCapacity: Integer);
    procedure  SetListCount(NewCount: integer);
  public
    destructor Destroy; override;
    function   Add(Item: Pointer): longInt;
    procedure  Clear;
    procedure  Delete(Index: longint);
    procedure  Exchange(Index1, Index2: longint);
    function   Expand: TSuperList;
    function   First: Pointer;
    function   FirstThat(const Fn: TSL_Function): Pointer;
    procedure  ForEach(const Proc: TSL_Procedure);
    procedure  FreeAll;
    procedure  FastFreeAll;
    procedure  FreeItem(var Item: Pointer);
    procedure  FastFreeItem(var Item: Pointer);
    function   IndexOf(Item: Pointer): longInt;
    procedure  Insert(Index: longint; Item: Pointer);
    function   Last: Pointer;
    procedure  Move(CurIndex, NewIndex: longint);
    function   Remove(Item: Pointer): longint;
    procedure  Pack;
    property   Capacity: Integer read FCapacity write SetCapacity;
    property   Count: longInt read FCount;
    property   Items[Index: longint]: Pointer read Get write Put; default;
    property   ListCount: integer read FListCount ;
end;
*)

TSuperList = class(TList)
public
   procedure  FreeAll;
   procedure  FastFreeAll;
   procedure  FreeItem(var Item: Pointer);
   procedure  FastFreeItem(var Item: Pointer);
end;

TEntity  = class;
TOrbisMessage = class;
TOrbisTextMessage = class;


TElement = class(TPersistent)

private
    FID: longInt;

protected
    function     GetInstanceSize: longInt; virtual;
    function     GetWholeSize : longInt; virtual;
    function     GetWholeSizes : longInt; virtual;
    function     GetName: string; virtual;
    procedure    SetName(aName: string); virtual;
    function     GetOwnerEntity(Index: longint): TEntity; virtual;
    procedure    PutOwner(Index: longint; Item: TEntity); virtual;
    function     GetOwnersCount: longint; virtual;
    function     GetLastPropertyIndex: integer;
public
    constructor  Create; virtual;
    destructor   Destroy; override;
    function     StoreName: boolean; virtual;
    procedure    Load(aReader: TReader; aIndex: TEntity); virtual;
    procedure    Save(aWriter: TWriter); virtual;
    function     LoadElement(aReader: TReader; aIndex: TEntity): TElement;
    procedure    SaveElement(aElement: TElement; aWriter: TWriter);
    function     NoElements: boolean; virtual;
    function     CreateEnvelope: TElement; virtual;
    procedure    HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
    procedure    OwnersHandleMessage(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
    procedure    SendMsg(Msg: longInt; Receiver, Data: TElement; KillData: boolean); virtual;
    procedure    PostMsg(Msg: longInt; Receiver, Data: TElement; KillData: boolean); virtual;
    procedure    PostTextMsg(Msg: longInt; aText: string; Receiver: TElement);
    procedure    SendMsgToOwners(Msg: longInt; Data: TElement; KillData: boolean); virtual;
    procedure    PostMsgToOwners(Msg: longInt; Data: TElement; KillData: boolean); virtual;
    procedure    PostTextMsgToOwners(Msg: longInt; aText: string);
    procedure    OnTimer; virtual;
    procedure    AddOwner(aOwner: TEntity); virtual;
    procedure    RemoveOwner(aOwner: TEntity); virtual;
    function     IsMyOwner(aOwner: TEntity): boolean; virtual;
    function     NoOwners: boolean; virtual;
    function     FindOwnerClass(aClass: TClass): TEntity; virtual;
    function     FindOwnerName(aName: string): TEntity; virtual;
    function     FindClassInOwners(aClass: TClass): TEntity; virtual;
    function     FindClassWithOwnerInOwners(aClass: TClass; aOwner: TEntity): TEntity; virtual;
    function     FindFirstClassWithOwnerInOwners(aClass: TClass; aOwner: TEntity): TEntity; virtual;
    function     IsPossibleToFree: boolean; virtual;
    procedure    ResetID; virtual;
    procedure    ResetIDs; virtual;
//    function     ExecuteCommandLine(aCommandLine: string): string; virtual;
//    function     ExecuteCommandLineToList(aCommandLine: string): TStringList; virtual;
//    function     ExecuteCommandLineToElement(aCommandLine: string): TElement; virtual;

    function     HasPropertyByName(aName: string): boolean; virtual;

    function     GetPropertyStringByName(AName: string): string; virtual;
    procedure    SetPropertyStringByName(AName: string; aValue: string); virtual;

    function     GetPropertyLongIntByName(AName: string): longInt; virtual;
    procedure    SetPropertyLongIntByName(AName: string; aValue: longInt); virtual;

    function     GetPropertyBooleanByName(AName: string): boolean; virtual;
    procedure    SetPropertyBooleanByName(AName: string; aValue: boolean); virtual;

    property     Owners[Index: longint]: TEntity read GetOwnerEntity write PutOwner; default;
    property     LastPropertyIndex: integer read GetLastPropertyIndex;
published
    property     ID: longInt read FID write FID stored false default -1 ;
    property     Name: string read GetName write SetName stored StoreName;
    property     OwnersCount: longInt read GetOwnersCount stored false;
    property     Size: longInt read GetInstanceSize stored false;
    property     WholeSize: longInt read GetWholeSize stored false;
end;

TElementClass = class of TElement;

TOrbisMessage = class(TElement)
 private
   procedure DoPostIt(aMsg: longInt);
   procedure DoSendIt(aMsg: longInt);
 protected
   FSender  : TElement;
   FReceiver: TElement;
   FMessage : longInt;
   FData    : TElement;
   FKillData: boolean;
   FTime    : TDateTime;
 public
   constructor CreateAll(aMessage: longInt; aSender, aReceiver, aData: TElement; KillData: boolean);
   destructor  Destroy; override;
   procedure   Send;
   procedure   Post;
published
   property   Message: longInt   read FMessage  write FMessage;
   property   Sender: TElement   read FSender   write FSender;
   property   Receiver: TElement read FReceiver write FReceiver;
   property   Data: TElement     read FData     write FData;
   property   KillData: boolean  read FKillData write FKillData default false;
   property   Time: TDateTime    read FTime     write FTime;
   property   PostIt: longInt    write DoPostIt;
   property   SendIt: longInt    write DoSendIt;
end;


TOrbisTextMessage = class(TOrbisMessage)
private
   FMessageText: {P}String;
   function  GetMessageText: string;
   procedure SetMessageText(aText: string);

 public
   destructor  Destroy; override;
 published
   property   Text: string read GetMessageText write SetMessageText;
end;



TNameElement = class(TElement)
 private
   FName: {P}String;
 protected
   function     GetInstanceSize: longInt; override;
   function     GetName: string; override;
   procedure    SetName(aName: string); override;
 public
   destructor   Destroy; override;
   function     StoreName: boolean; override;
   procedure    Load(aReader: TReader; aIndex: TEntity); override;
   procedure    Save(aWriter: TWriter); override;
end;


TOwnerElement = class(TNameElement)
protected
    FOwners: TSuperList;         { ElementList }
    function     GetOwnerEntity(Index: longint): TEntity; override;
    procedure    PutOwner(Index: longint; Item: TEntity); override;
    function     GetOwnersCount: longint; override;
public
    destructor   Destroy; override;
    procedure    AddOwner(aOwner: TEntity); override;
    procedure    RemoveOwner(aOwner: TEntity); override;
    function     IsMyOwner(aOwner: TEntity): boolean; override;
    function     NoOwners: boolean; override;
    function     FindOwnerClass(aClass: TClass): TEntity; override;
    function     FindOwnerName(aName: string): TEntity; override;
end;

{ procedura a funkce pro hromadn operace Entity }
TE_Procedure = procedure(var Element: TElement);
TE_Function  = function(var Element: pointer): boolean;


TAliasElement = class(TOwnerElement)
private
   FElement: TElement;
public
   property Element: TElement read FElement write FElement;
end;


TEntity = class(TElement)
private
    function     GetWholeCount: longInt;
    function     GetWholeCounts: longInt;
    procedure SetElementToFree(const Value: TElement);
protected
    FElements: TSuperList;         { ElementList }
    function     GetWholeSizes : longInt; override;
    function     ElementsCount: longInt; virtual;
    function     GetLastIndex: longInt; virtual;
    function     Get(Index: longint): TElement; virtual;
    procedure    Put(Index: longint; Item: TElement); virtual;
    function     GetElement(aName: string): TElement;
    procedure    SetElement(aName: string; aElement: TElement);
    procedure    PAddAllFrom(aEl: TElement);
    procedure    RAddAllFrom(aEl: TElement);

public
    destructor   Destroy; override;
    procedure    Load(aReader: TReader; aIndex: TEntity); override;
    procedure    Save(aWriter: TWriter); override;
    function     CreateEnvelope: TElement; override;
    function     IndexOf(aElement: TElement): longInt; virtual;
    //function     FirstThat(Fn: TE_Function): TElement;
    //procedure    ForEach(Proc: TE_Procedure);
    procedure    FastFreeAll;
    procedure    FreeAll; virtual;
    procedure    HardFreeAll;
    procedure    Clear;
    procedure    HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean); override;
    procedure    OnTimer; override;
    function     CreateElement(const aClass, aName: string): TElement; virtual;
    function     FindOrCreateElementName(const aClass: TElementClass; const aName: string): TElement;
    procedure    AddElement(aElement: TElement); virtual;
    procedure    InsertElement(aIndex: longInt; aElement: TElement); virtual;
    procedure    RemoveElement(aElement: TElement); virtual;
    procedure    RemoveElementIndex(aIndex: integer); virtual;
    procedure    FreeElement(aElement: TElement); virtual;
    procedure    FreeElementIndex(aIndex: integer); virtual;
    procedure    ExchangeElements(Element1, Element2: TElement);
    procedure    ExchangeElementsIndex(aIndex1,aIndex2: integer);
    procedure    ExchangeFieldElement(var aField: TElement; const aElement: TElement);
    function     NoElements: boolean; override;
    function     FindElementClass(aClass: TClass): TElement; virtual;
    function     FindElementName(aName: string): TElement; virtual;
    function     CanFreeElement(aElement: TElement): boolean; virtual;
    procedure    GetElements(aEntity: TEntity; aFrom, aTo: longInt);
    function     GetClassCount(aClass: TElementClass): longInt;
    procedure    ResetIDs; override;

    property     Elements[Index: longint]: TElement read Get write Put;
    property     Element[aName: string]: TElement read GetElement write SetElement;
published
    property     NextElement: TElement write AddElement stored false;
    property     ElementToFree: TElement write SetElementToFree stored false;
    property     ElementToRemove: TElement write RemoveElement stored false;
    property     AddAllFrom: TElement write PAddAllFrom stored false;
    property     AddAllFromRev: TElement write RAddAllFrom stored false;
    property     WholeCount: longInt read GetWholeCount stored false;
    property     Count: longInt read ElementsCount stored false;
    property     LastIndex: longInt read GetLastIndex stored false;
end;


TAliases = class (TEntity)
private
   function  GetAlias(aName: string): TElement;
   procedure SetAlias(aName: string; aElement: TElement);
public
   property Alias[aName: string]: TElement read GetAlias write SetAlias;
end;



TQuickEntity = class(TEntity)
private
    procedure SetClearIt(const Value: boolean);
public
    procedure  AddElement(aElement: TElement); override;
    procedure  InsertElement(aIndex: longInt; aElement: TElement); override;
published
    property   ClearIt: boolean write SetClearIt stored false;
end;


TEnvelopeEntity = class(TEntity)
protected
    FOwner: TEntity;
    procedure  SetOwner(aOwner: TEntity);
    {
    procedure  AddOwners;
    procedure  RemoveOwners;
    }
public
    {
    procedure  AddElement(aElement: TElement); override;
    procedure  InsertElement(aIndex: longInt; aElement: TElement); override;
    procedure  RemoveElement(aElement: TElement); override;
    }
    procedure  AddOwner(aOwner: TEntity); override;
    function   FindOwnerClass(aClass: TClass): TEntity; override;
    function   FindClassInOwners(aClass: TClass): TEntity; override;
    function   FindClassWithOwnerInOwners(aClass: TClass; aOwner: TEntity): TEntity; override;
    function   FindFirstClassWithOwnerInOwners(aClass: TClass; aOwner: TEntity): TEntity; override;
    procedure  HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean); override;

    property   Owner: TEntity read FOwner write SetOwner;
end;


TNameEntity = class(TEntity)
 protected
   FName: {P}String;
   function     GetInstanceSize: longInt; override;
   function     GetName: string; override;
   procedure    SetName(aName: string); override;
 public
   destructor   Destroy; override;
   function     StoreName: boolean; override;
   procedure    Load(aReader: TReader; aIndex: TEntity); override;
   procedure    Save(aWriter: TWriter); override;
end;

TOwnerEntity = class(TNameEntity)
private
    procedure   InsertNameSortedEntity(Entity: TNameEntity);

protected
    FOwners: TSuperList;
    function     GetOwnerEntity(Index: longint): TEntity; override;
    procedure    PutOwner(Index: longint; Item: TEntity); override;
    function     GetOwnersCount: longint; override;
public
    destructor   Destroy; override;
    procedure    AddOwner(aOwner: TEntity); override;
    procedure    RemoveOwner(aOwner: TEntity); override;
    function     IsMyOwner(aOwner: TEntity): boolean; override;
    function     NoOwners: boolean; override;
    function     FindOwnerClass(aClass: TClass): TEntity; override;
    function     FindOwnerName(aName: string): TEntity; override;
    function     CreateSubEntity
                 (aClass: TElementClass; aName: string): TNameEntity;
end;


//function CreateElementByName(aClassName: string): TElement;
procedure ResetBaseID;
{!!!}
procedure CheckTestedElement;

const
   {!!}TestedElement: TOwnerElement = nil;

{$IFDEF OCX}
   MessageHandle: integer = 0;
{$ENDIF}

var
   BaseID: longInt;
  {$IFDEF OrbisRegister}
   OrbisRegister: TQuickEntity;
  {$ENDIF}



implementation

uses
{$IFDEF OrbisRegister}
   Worlds,
{$ENDIF}
   FMX.Dialogs, FMX.Controls,
   FMX.Consts, FMX.Forms,
   System.UITypes,
 { F_HTool, }
   SysUtils;
//   e_Class,
   {!t_Main,}
//   U_String,
//   u_Props;

procedure ResetBaseID;
var
   i: integer;
begin
   Randomize;
   i := BaseID;
   repeat
      BaseID := -(Random(32000));
   until i <> BaseID;
   //Application.ProcessMessages;
   {!PK : Bez tohodle ekn nefunguje ukldn (nkdy)}
   (*
   for i := 0 to 1000000 do
   begin
   end;
   *)
   {
   ShowMessage('Base:'+ IntToStr(BaseID));
   }
end;

// //test android
//function CreateElementByName(aClassName: string): TElement;
//var
//  aClass: TElementClass;
//begin
//  result:= nil;
//  try
//    aClass := TElementClass(GetOrbisClass(aClassName));
//
//    if aClass = nil then
//    begin
//      aClassName:= 'T' + aClassName;
//      aClass := TElementClass(GetOrbisClass(aClassName))
//    end;
//
//    if aClass = nil then
//       MessageDlg('Neregistrovan element: '+ aClassName, TMsgDlgType.mtError, [TMsgDlgBtn.mbOK], 0)
//    else
//      result := TElement(aClass.Create)
//  except
//  end;
//end;


{ TSuperList }


(*
destructor TSuperList.Destroy;
var
   i: integer;
begin
   if ListCount > 0 then
   for i := 0 to ListCount - 1 do
   begin
      if Assigned(FList^[i]) then FList^[i].Destroy;
   end;
   Clear;
   inherited Destroy;
end;

function TSuperList.Add(Item: Pointer): longInt;
var
   ListIndex: integer;
begin
   Result    := FCount;
   ListIndex := Fcount div MaxListCapacity;
   if ListIndex = FListCount then AddList;
   FList^[ListIndex].Add(Item);
   Inc(FCount);
end;

function TSuperList.AddList: integer;
begin
   Result := FListCount;
   if Result = FCapacity then Grow;
   FList^[Result] := TList.Create;
   Inc(FListCount);
end;

procedure TSuperList.Clear;
var
   i: longInt;
begin
   for i := 0 to ListCount -1 do
   begin
      FList^[i].clear;
   end;
   SetListCount(0);
   SetCapacity(0);
   FCount := 0;
end;

procedure TSuperList.Delete(Index: longInt);
var
   ListIndex : integer;
   LastListIndex: integer;
   localIndex: integer;
   i: integer;
begin
   { vpoet index listu }
   LastListIndex := ListCount - 1;
   ListIndex     := Index div MaxListCapacity;
   LocalIndex    := Index mod MaxListCapacity;
   { Index je mimo msu }
   if (Index < 0) or (Index >= FCount) then Error;
   { Snit poet }
   Dec(FCount);
   { Smazat prvek }
   FList^[ListIndex].Delete(LocalIndex);
   { Pokud to nebylo v poslednm listu, posunout fude }
   if ListIndex < LastListIndex then
   for i := ListIndex to (LastListIndex - 1) do
   begin
      FList^[i].Add(FList^[i+1].Items[0]);
      FList^[i+1].Delete(0);
   end;
   { Nen posledn List przdn ? }
   if FList^[LastListIndex].Count = 0 then RemoveLastList;
end;

procedure TSuperList.Error;
begin
   raise EListError.Create(LoadStr(SListIndexError));
end;

procedure TSuperList.Exchange(Index1, Index2: longInt);
var
   Item: Pointer;
   ListIndex1 : integer;
   LocalIndex1: integer;
   ListIndex2 : integer;
   LocalIndex2: integer;
begin
   if (Index1 < 0) or (Index1 >= FCount) or
     (Index2 < 0) or (Index2 >= FCount) then Error;
   ListIndex1  := Index1 div MaxListCapacity;
   LocalIndex1 := Index1 mod MaxListCapacity;
   ListIndex2  := Index2 div MaxListCapacity;
   LocalIndex2 := Index2 mod MaxListCapacity;
   Item := FList^[ListIndex1].Items[LocalIndex1];
   FList^[ListIndex1].Items[LocalIndex1] := FList^[ListIndex2].Items[LocalIndex2];
   FList^[ListIndex2].Items[LocalIndex2] := Item;
end;

function TSuperList.Expand: TSuperList;
begin
   if FListCount = FCapacity then Grow;
   Result := Self;
end;

function TSuperList.First: Pointer;
begin
   Result := Get(0);
end;

function   TSuperList.FirstThat(const Fn: TSL_Function): Pointer;
var
  i,j: longInt;
  P: pointer;
begin
   Result := nil;
   for i := 0 to FListCount - 1 do
       for j := 0 to FList^[i].Count - 1 do
       begin
          P := FList^[i].Items[j];
          if Fn(P) then
          begin
             Result := FList^[i].Items[j];
             exit;
          end;
       end;
end;

procedure  TSuperList.ForEach(const Proc: TSL_Procedure);
var
  i,j: longInt;
  P: pointer;
begin
    for i := 0 to FListCount - 1 do
        for j := 0 to FList^[i].Count - 1 do
        begin
           P := FList^[i].Items[j];
           Proc(P);
        end;
end;

procedure  TSuperList.FreeAll;
var
  i,j: longInt;
  P: pointer;
begin
    for i := 0 to FListCount - 1 do
        for j := FList^[i].Count - 1 Downto 0 do
        begin
           P := FList^[i].Items[j];
           FreeItem(P);
        end;
end;

procedure  TSuperList.FastFreeAll;
var
  i,j: longInt;
  P: pointer;
begin
    for i := 0 to FListCount - 1 do
        for j := FList^[i].Count - 1 Downto 0 do
        begin
           P := FList^[i].Items[j];
           FastFreeItem(P);
        end;
    Clear;
end;


procedure  TSuperList.FreeItem(var Item: Pointer);
begin
   if not assigned(Item) then exit;
   if TElement(Item).IsPossibleToFree then TElement(Item).Free;
end;


procedure  TSuperList.FastFreeItem(var Item: Pointer);
begin
   if not assigned(Item) then exit;
   if (TElement(Item) is TEntity) then
   begin
      TEntity(Item).FastFreeAll;
   end;
   TElement(Item).Free;
end;



function TSuperList.Get(Index: longInt): Pointer;
var
   ListIndex : integer;
   localIndex: integer;
begin
   if (Index < 0) or (Index >= FCount) then
      Error;
   { calculate indexes... }
   ListIndex  := Index div MaxListCapacity;
   LocalIndex := Index mod MaxListCapacity;
   { and result... }
   Result := FList^[ListIndex].Items[LocalIndex];
end;

procedure TSuperList.Grow;
begin
   SetCapacity(FCapacity + 1);
end;

function TSuperList.IndexOf(Item: Pointer): longInt;
var
   i: longInt;
begin
   i      := 0;
   Result := -1;
   while i < FListCount do
   begin
      Result := FList^[i].IndexOf(Item);
      if Result > -1 then
      begin
         Result := Result +(i * MaxListCapacity);
         break;
      end;
      inc(i);
   end;
end;


procedure TSuperList.Insert(Index: longInt; Item: Pointer);
var
   ListIndex : integer;
   LastIndex : integer;
   LastListIndex: integer;
   localIndex: integer;
   i: integer;
begin
   if Index = FCount then
   begin
      Add(Item);
      exit
   end;
   { vpoet index listu }
   LastListIndex := ListCount - 1;
   ListIndex     := Index div MaxListCapacity;
   LocalIndex    := Index mod MaxListCapacity;
   { Index je mimo msu }
   if (Index < 0) or (Index > FCount) then Error;
   { Insert Item }
   FList^[ListIndex].Insert(LocalIndex, Item);
   { Pokud to nebylo v poslednm listu, posunout fude }
   LastIndex := MaxListCapacity;
   if ListIndex < LastListIndex then
   for i := ListIndex to (LastListIndex - 1) do
   begin
      FList^[i+1].Insert(0,FList^[i].Items[LastIndex]);
      FList^[i].Delete(LastIndex);
   end;
   { Nem toho posledn List moc ? }
   if FList^[LastListIndex].Count > MaxListCapacity then
   begin
      AddList;
      i := LastListIndex;
      FList^[i+1].Add(FList^[i].Items[LastIndex]);
      FList^[i].Delete(LastIndex);
   end;
   Inc(FCount);
end;

function TSuperList.Last: Pointer;
begin
  Result := FList^[ListCount-1].Last;
end;

procedure TSuperList.Move(CurIndex, NewIndex: longInt);
var
  Item: Pointer;
begin
  if CurIndex <> NewIndex then
  begin
    if (NewIndex < 0) or (NewIndex >= FCount) then Error;
    Item := Get(CurIndex);
    Delete(CurIndex);
    Insert(NewIndex, Item);
  end;
end;

procedure TSuperList.Put(Index: longInt; Item: Pointer);
var
   ListIndex : integer;
   localIndex: integer;
begin
   if (Index < 0) or (Index >= FCount) then Error;
   { calculate indexes... }
   ListIndex  := Index div MaxListCapacity;
   LocalIndex := Index mod MaxListCapacity;
   FList^[ListIndex].Items[LocalIndex] := Item;
end;




function TSuperList.Remove(Item: Pointer): longInt;
begin
  Result := IndexOf(Item);
  if Result <> -1 then Delete(Result);
end;

procedure TSuperList.RemoveLastList;
begin
  if WordBool(FListCount) then
  begin
     FList^[FListCount - 1].Free;
     dec(FListCount);
  end;
end;

procedure TSuperList.Pack;
var
  I: Integer;
begin
  for I := FCount - 1 downto 0 do if Items[I] = nil then Delete(I);
end;

procedure TSuperList.SetCapacity(NewCapacity: Integer);
var
  NewList: PListArray;
begin
  if (NewCapacity < FListCount) or (NewCapacity > MaxListSize) then Error;
  if NewCapacity <> FCapacity then
  begin
    if NewCapacity = 0 then NewList := nil else
    begin
      GetMem(NewList, NewCapacity * SizeOf(Pointer));
      if FListCount <> 0 then
        System.Move(FList^, NewList^, FListCount * SizeOf(Pointer));
    end;
    if FCapacity <> 0 then FreeMem(FList, FCapacity * SizeOf(Pointer));
    FList := NewList;
    FCapacity := NewCapacity;
  end;
end;

procedure TSuperList.SetListCount(NewCount: Integer);
begin
  if (NewCount < 0) or (NewCount > MaxListSize) then Error;
  if NewCount > FCapacity then SetCapacity(NewCount);
  if NewCount > FListCount then
    FillChar(FList^[FListCount], (NewCount - FListCount) * SizeOf(Pointer), 0);
  FListCount := NewCount;
end;

*)


procedure  TSuperList.FreeAll;
var
  i: longInt;
  P: pointer;
begin
   for i := Count - 1 Downto 0 do
   begin
      P := Items[i];
      FreeItem(P);
   end;
end;

procedure  TSuperList.FastFreeAll;
var
  i: longInt;
  P: pointer;
begin
    for i := Count - 1 Downto 0 do
    begin
       P := Items[i];
       FastFreeItem(P);
    end;
    Clear;
end;


procedure  TSuperList.FreeItem(var Item: Pointer);
begin
   if not assigned(Item) then exit;
   if TElement(Item).IsPossibleToFree then TElement(Item).Free;
end;


procedure  TSuperList.FastFreeItem(var Item: Pointer);
begin
   if not assigned(Item) then exit;
   if (TElement(Item) is TEntity) then
   begin
      TEntity(Item).FastFreeAll;
   end;
   TElement(Item).Free;
end;




{ TOrbisMessage }


constructor TOrbisMessage.CreateAll(aMessage: longInt; aSender, aReceiver,aData: TElement; KillData: boolean);
begin
   inherited Create;
   Message := aMessage;
   Sender  := aSender;
   Receiver := aReceiver;
   Data := aData;
   Time := Now;
end;


destructor  TOrbisMessage.Destroy;
begin
   if KillData then
   try
      Data.Free;
   except
   end;
   inherited Destroy;
end;


procedure   TOrbisMessage.Send;
begin
// events
//{$IFDEF OCX}
//   if MessageHandle = 0 then MessageHandle := HInstance{Application.Handle};
//   SendMessage(MessageHandle, WM_ORBISMESSAGE, TM_ORBISMESSAGE, longInt(Self));
//{$ELSE}
//   SendMessage(Application.Handle, WM_ORBISMESSAGE, TM_ORBISMESSAGE, longInt(Self));
//{$ENDIF}
end;

procedure   TOrbisMessage.Post;
begin
//events
//{$IFDEF OCX}
//   if MessageHandle = 0 then
//   begin
//      //Application.Handle := HInstance;
//      MessageHandle := Application.Handle;
//   end;
//   PostMessage(MessageHandle, WM_ORBISMESSAGE, TM_ORBISMESSAGE, longInt(Self));
//{$ELSE}
//   PostMessage(Application.Handle, WM_ORBISMESSAGE, TM_ORBISMESSAGE, longInt(Self));
//{$ENDIF OCX}
end;

procedure TOrbisMessage.DoPostIt(aMsg: longInt);
begin
  if aMsg <> 0 then Message:= aMsg;
  Post
end;


procedure TOrbisMessage.DoSendIt(aMsg: longInt);
begin
  if aMsg <> 0 then Message:= aMsg;
  Send
end;




             { TOrbisTextMessage }

function TOrbisTextMessage.GetMessageText: string;
begin
   //Result:= GetPString(FMessageText)
   result:= FMessageText;
end;

procedure TOrbisTextMessage.SetMessageText(aText: string);
begin
   //SetPString(FMessageText, aText)
   FMessageText := aText;
end;

destructor  TOrbisTextMessage.Destroy;
begin
//  if assigned(FMessageText) then DisposeStr(FMessageText);
   FMessageText := '';
   inherited Destroy
end;


{ TElement }

constructor  TElement.Create;
begin
   inherited Create;
   ID := -1;
{!O.S.}
{$IFDEF OrbisRegister}
   if OrbisRegister = nil then exit;
   OrbisRegister.AddElement(self)
{$ENDIF}
end;


destructor TElement.Destroy;
begin
{$IFDEF OrbisRegister}
   if OrbisRegister = nil then
      ShowMessage('Orbis Register = nil')
   else
   if  OrbisRegister.Count = 0 then
       ShowMessage('Orbis Register.Count = 0')
   else
   if OrbisRegister.IndexOf(self) < 0 then
      ShowMessage('V Orbis Registru nebyl nalezen objekt' + self.ClassName + ':' + self.Name)
   else
     OrbisRegister.RemoveElement(self);
{$ENDIF}
  inherited Destroy
end;

procedure    TElement.Load(aReader: TReader; aIndex: TEntity);
begin
   ID := aReader.ReadInteger;
end;

function TElement.GetInstanceSize: longInt;
begin
  result:= self.InstanceSize;
end;


procedure    TElement.Save(aWriter: TWriter);
begin
   aWriter.WriteString(ClassName);
   aWriter.WriteInteger(ID);
end;

function     TElement.LoadElement(aReader: TReader; aIndex: TEntity): TElement;
var
   i: longInt;
begin
   i := aReader.ReadInteger;
   if i > -1 then result := aIndex.Elements[i]
             else result := nil;
end;


procedure    TElement.SaveElement(aElement: TElement; aWriter: TWriter);
begin
   if aElement <> nil then aWriter.WriteInteger(aElement.ID)
                      else aWriter.WriteInteger(-1);

end;


function TElement.NoElements: boolean;
begin
   result := true;
end;


function TElement.GetWholeSize: longInt;
begin
   ResetBaseID;
   result:= GetWholeSizes;
end;

function TElement.GetWholeSizes: longInt;
begin
   ID := BaseID;
   result:= Size
end;


function     TElement.GetName: string;
begin
   Result := ClassName;
end;


procedure    TElement.SetName(aName: string);
begin
end;


function     TElement.GetLastPropertyIndex: integer;
begin
//   result := GetPropCount(Self) - 1;
   result := 0;  //@rad
end;


function     TElement.GetOwnerEntity(Index: longint): TEntity;
begin
   Result := nil;
end;


procedure    TElement.PutOwner(Index: longint; Item: TEntity);
begin
end;


function     TElement.GetOwnersCount: longint;
begin
   Result := 0;
end;


function     TElement.CreateEnvelope: TElement;
begin
   result := TElement(ClassType.Create);
   result.Name := 'Oblka: ' + Name;
end;


procedure   TElement.HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean);
begin
end;

procedure   TElement.OwnersHandleMessage(var aMessage: TOrbisMessage; var Handled: boolean);
var
   i: longInt;
   O: TEntity;
begin
   if NoOwners then
   begin
      Handled := true;
      exit;
   end;
   for i := 0 to OwnersCount -1 do
   begin
     try
      O := Owners[i];
      if Assigned(O) then O.HandleMessage(aMessage, Handled);
      if Handled then break;
     except
      MessageDlg(IntToStr(aMessage.Message), TMsgDlgType.mtError, [TMsgDlgBtn.mbOK],0);
     end;
   end;
   Handled := true;
end;


procedure    TElement.SendMsg(Msg: longInt; Receiver, Data: TElement; KillData: boolean);
var
   OM: TOrbisMessage;
begin
   OM := TOrbisMessage.CreateAll(Msg, Self, Receiver, Data, KillData);
   OM.Send;
end;

procedure    TElement.PostMsg(Msg: longInt; Receiver, Data: TElement; KillData: boolean);
var
  OM: TOrbisMessage;
begin
   OM := TOrbisMessage.CreateAll(Msg, Self, Receiver, Data, KillData);
   OM.Post;
end;

procedure   TElement.PostTextMsg(Msg: longInt; aText: string; Receiver: TElement);
var
  OM: TOrbisTextMessage;
begin
   OM := TOrbisTextMessage.CreateAll(Msg, Self, Receiver, nil, false);
   OM.Text:= aText;
   OM.Post;
end;

procedure    TElement.SendMsgToOwners(Msg: longInt; Data: TElement; KillData: boolean);
var
  OM: TOrbisMessage;
  i: longInt;
begin
   for i := 0 to OwnersCount - 1 do
   begin
      OM := TOrbisMessage.CreateAll(Msg, Self, Owners[i], Data, KillData);
      OM.Send;
   end;
end;

procedure    TElement.PostMsgToOwners(Msg: longInt; Data: TElement; KillData: boolean);
var
  OM: TOrbisMessage;
  i: longInt;
begin
   for i := 0 to OwnersCount - 1 do
   begin
      OM := TOrbisMessage.CreateAll(Msg, Self, Owners[i], Data, KillData);
      OM.Post;
   end;
end;

procedure    TElement.PostTextMsgToOwners(Msg: longInt; aText: string);
var
  OM: TOrbisTextMessage;
  i: longInt;
begin
   for i := 0 to OwnersCount - 1 do
   begin
      OM := TOrbisTextMessage.CreateAll(Msg, Self, Owners[i], nil, false);
      OM.Text:= aText;
      OM.Post;
   end;
end;



procedure    TElement.OnTimer;
begin
end;

procedure    TElement.AddOwner(aOwner: TEntity);
begin
end;


procedure    TElement.RemoveOwner(aOwner: TEntity);
begin
end;

function     TElement.IsMyOwner(aOwner: TEntity): boolean;
begin
   Result := false;
end;


function     TElement.NoOwners: boolean;
begin
   Result := (OwnersCount <= 0);
end;


function     TElement.FindOwnerClass(aClass: TClass): TEntity;
begin
   Result := nil;
end;

function     TElement.FindOwnerName(aName: string): TEntity;
begin
   Result := nil;
end;

function     TElement.FindClassInOwners(aClass: TClass): TEntity;
var
   i: longInt;
begin
   Result := nil;
   if Self is aClass then
   begin
      result := TEntity(Self);
      exit;
   end;
   if NoOwners then exit;
   for i := 0 to OwnersCount - 1 do
   begin
      result := Owners[i].FindClassInOwners(aClass);
      if result <> nil then exit;
   end;
end;

function     TElement.FindClassWithOwnerInOwners(aClass: TClass; aOwner: TEntity): TEntity;
var
   i: longInt;
begin
   Result := nil;
   if Self is aClass then
   begin
      if IsMyOwner(aOwner) then
      begin
         result := TEntity(Self);
         exit;
      end;
   end;
   if NoOwners then exit;
   for i := 0 to OwnersCount - 1 do
   begin
      result := Owners[i].FindClassWithOwnerInOwners(aClass,aOwner);
      if result <> nil then exit;
   end;
end;

function TElement.FindFirstClassWithOwnerInOwners(aClass: TClass; aOwner: TEntity): TEntity;
var
   i: longInt;
begin
   Result := nil;
   if Self is aClass then
   begin
      if IsMyOwner(aOwner) then
         result := TEntity(Self);
      exit;
   end;
   if NoOwners then exit;
   for i := 0 to OwnersCount - 1 do
   begin
      result := Owners[i].FindFirstClassWithOwnerInOwners(aClass,aOwner);
      if result <> nil then exit;
   end;
end;


function     TElement.IsPossibleToFree: boolean;
var
   i, C: longInt;
begin
   C := OwnersCount;
   result := true;
   if C <= 1 then exit;
   for i := 0 to C - 1 do
   begin
      if not Owners[i].CanFreeElement(Self) then
      begin
         result := false;
         exit;
      end;
   end;
end;


procedure   TElement.ResetID;
begin
   ResetBaseID;
   ResetIDs;
end;


procedure   TElement.ResetIDs;
begin
   ID := BaseID;
end;


//test android
//function     TElement.ExecuteCommandLine(aCommandLine: string): string;
//var
//   Delimiter: char;
//   Delimiters: TDelimiters;
//   Position: longInt;
//   S: string;
//   Param: string;
//   E: TPersistent;
//   Pom: longInt;
//
//   procedure EX(ms: string);
//   begin
//      raise Exception.Create(ms);
//   end;
//
//   function EvaluateMethod: TElement;
//   begin
//      result := nil;
//      if not (E is TEntity) then Ex('Objekt na pozici '+ IntToStr(Position -2) + ' nen Entita ... nelze prohledvat');
//      Param := ReadToDelimiterWithoutWS(aCommandLine,  Delimiters, Position, Delimiter, Position);
//      if UpperCase(S) = ce_FindElementByName then
//      begin
//         result := TEntity(E).FindElementName(Param);
//      end
//      else
//      if (UpperCase(S) = ce_FindElementByClass) then
//      begin
//         result := TEntity(E).FindElementClass(FindOrbisClass(Param));
//      end;
//      if not (Delimiter = ')') then Ex('Chyba syntaxe. .. na pozici '+ IntToStr(Position -1)+' '+'oekvm ")"');
//      Pom := Position - 1;
//      S := ReadToDelimiterWithoutWS(aCommandLine,  Delimiters, Position, Delimiter, Position);
//      if not (Delimiter = '.') then Ex('Chyba syntaxe. .. na pozici '+ IntToStr(Pom)+' '+'oekvm "."');
//   end;
//
//   function EvaluateProperty: string;
//   begin
//      if E is TElement then result := TElement(E).GetPropertyStringByName(S)
//                       else result := GetPropStringByName(E, S);
//   end;
//
//   function EvaluatePropertyAsObject: TPersistent;
//   begin
//      result := TPersistent(GetObjectPropByName(E,S));
//   end;
//
//begin
//   E := Self;
//   Position := 1;
//   Delimiters := ['.','(',')'];
//   result := '';
//
//   while true do
//   begin
//      if E = nil then Ex('Chyba ... nenalezl jsem objekt '+ Param );
//      if not(E is TPersistent) then Ex(' Dan objekt nelze zkoumat');
//      S := ReadToDelimiterWithoutWS(aCommandLine,  Delimiters, Position, Delimiter, Position);
//      case Delimiter of
//         #0: { properta - konec }
//         begin
//            result := EvaluateProperty;
//            exit;
//         end;
//         '.': { properta - objekt }
//         begin
//            E := EvaluatePropertyAsObject;
//         end;
//         '(':
//         begin
//            E := EvaluateMethod;
//         end;
//      end;
//   end;
//end;
//
//
//function     TElement.ExecuteCommandLineToElement(aCommandLine: string): TElement;
//var
//   Delimiter: char;
//   Delimiters: TDelimiters;
//   Position: longInt;
//   S: string;
//   Param: string;
//   E: TElement;
//   Pom: longInt;
//   List: TStringList;
//
//   procedure EX(ms: string);
//   begin
//      List.Free;
//      List := nil;
//      raise Exception.Create(ms);
//   end;
//
//   function EvaluateMethod: TElement;
//   begin
//      result := nil;
//      if not (E is TEntity) then Ex('Objekt na pozici '+ IntToStr(Position -2) + ' nen Entita ... nelze prohledvat');
//      Param := ReadToDelimiterWithoutWS(aCommandLine,  Delimiters, Position, Delimiter, Position);
//      if UpperCase(S) = ce_FindElementByName then
//      begin
//         result := TEntity(E).FindElementName(Param);
//      end
//      else
//      if UpperCase(S) = ce_FindElementByClass then
//      begin
//         result := TEntity(E).FindElementClass(FindOrbisClass(Param));
//      end;
//      if not (Delimiter = ')') then Ex('Chyba syntaxe. .. na pozici '+ IntToStr(Position -1)+' '+'oekvm ")"');
//      Pom := Position - 1;
//      S := ReadToDelimiterWithoutWS(aCommandLine,  Delimiters, Position, Delimiter, Position);
//   end;
//
//   procedure  EvaluateProperty;
//   begin
//      if E is TElement then List.Add(TElement(E).GetPropertyStringByName(S))
//                       else List.Add(GetPropStringByName(E, S));
//   end;
//
//   function EvaluatePropertyAsObject: TElement;
//   begin
//      result := TElement(GetObjectPropByName(E,S));
//   end;
//
//begin
//   E := Self;
//   Position := 1;
//   Delimiters := ['.','(',')'];
//   result := nil;
//
//   while true do
//   begin
//      if E = nil then Ex('Chyba ... nenalezl jsem objekt '+ Param );
//      if not(E is TPersistent) then Ex(' Zkouman objekt ' + Self.Name + ' je nevhodny');
//      S := ReadToDelimiterWithoutWS(aCommandLine,  Delimiters, Position, Delimiter, Position);
//      case Delimiter of
//         #0: { properta - konec }
//         begin
//            E:= EvaluatePropertyAsObject;
//            break;
//         end;
//         '.': { properta - objekt }
//         begin
//            E := EvaluatePropertyAsObject;
//            if Delimiter = #0 then
//               break
//         end;
//         '(':
//         begin
//            E := EvaluateMethod;
//            if Delimiter = #0 then
//               break
//         end;
//      end;
//   end;
//   if E is TElement then
//      result:= E
//end;
//
//test android
//function     TElement.ExecuteCommandLineToList(aCommandLine: string): TStringList;
//var
//   Delimiter: char;
//   Delimiters: TDelimiters;
//   Position: longInt;
//   S: string;
//   Param: string;
//   E: TPersistent;
//   Pom: longInt;
//   List: TStringList;
//
//   procedure EX(ms: string);
//   begin
//      List.Free;
//      List := nil;
//      raise Exception.Create(ms);
//   end;
//
//   function EvaluateMethod: TElement;
//   begin
//      result := nil;
//      if not (E is TEntity) then Ex('Objekt na pozici '+ IntToStr(Position -2) + ' nen Entita ... nelze prohledvat');
//      Param := ReadToDelimiterWithoutWS(aCommandLine,  Delimiters, Position, Delimiter, Position);
//      if UpperCase(S) = ce_FindElementByName then
//      begin
//         result := TEntity(E).FindElementName(Param);
//      end
//      else
//      if UpperCase(S) = ce_FindElementByClass then
//      begin
//         result := TEntity(E).FindElementClass(FindOrbisClass(Param));
//      end;
//      if not (Delimiter = ')') then Ex('Chyba syntaxe. .. na pozici '+ IntToStr(Position -1)+' '+'oekvm ")"');
//      Pom := Position - 1;
//      S := ReadToDelimiterWithoutWS(aCommandLine,  Delimiters, Position, Delimiter, Position);
//      if not (Delimiter = '.') then Ex('Chyba syntaxe. .. na pozici '+ IntToStr(Pom)+' '+'oekvm "."');
//   end;
//
//   procedure  EvaluateProperty;
//   begin
//      if E is TElement then List.Add(TElement(E).GetPropertyStringByName(S))
//                       else List.Add(GetPropStringByName(E, S));
//   end;
//
//   function EvaluatePropertyAsObject: TPersistent;
//   begin
//      result := TPersistent(GetObjectPropByName(E,S));
//   end;
//
//   procedure FillList;
//   var
//      i: longInt;
//   begin
//      if not(E is TEntity) then
//      if not(E is TElement)then Ex('Posledn objekt nen ani Element, nato Entita !')
//                           else Ex('Posledn objekt nen Entita - nelze vytvoit seznam !');
//      S := ReadToDelimiterWithoutWS(aCommandLine,  Delimiters, Position, Delimiter, Position);
//      if Delimiter <> #0 then Ex('Chybn zakonen pkazu: '+ Delimiter);
//      for i := 0 to TEntity(E).Count - 1 do
//      begin
//         List.Add(TEntity(E).Elements[i].GetPropertyStringByName(S));
//      end;
//   end;
//
//begin
//   E := Self;
//   Position := 1;
//   Delimiters := ['.','(',')'];
//   List := TStringList.Create;
//   result := List;
//
//   while true do
//   begin
//      if E = nil then Ex('Chyba ... nenalezl jsem objekt '+ Param );
//      if not(E is TPersistent) then Ex(' Zkouman objekt ' + Self.Name + ' je nevhodny');
//      S := ReadToDelimiterWithoutWS(aCommandLine,  Delimiters, Position, Delimiter, Position);
//      case Delimiter of
//         #0: { properta - konec }
//         begin
//            EvaluateProperty;
//            exit;
//         end;
//         '.': { properta - objekt }
//         begin
//            if UpperCase(S)= ce_Element then
//            begin
//               FillList;
//               exit;
//            end;
//            E := EvaluatePropertyAsObject;
//         end;
//         '(':
//         begin
//            E := EvaluateMethod;
//         end;
//      end;
//   end;
//end;


function   TElement.HasPropertyByName(aName: string): boolean;
begin
//  result:= GetPropIndex(Self, aName) > -1;
   result := false; // @rad
end;

function     TElement.GetPropertyStringByName(AName: string): string;
begin
//   result := GetPropStringByName(Self, aName);
   result := '0'; //@rad
end;


procedure    TElement.SetPropertyStringByName(AName: string; aValue: string);
begin
//   SetPropStringByName(Self, aName, aValue); //@rad
end;

function     TElement.GetPropertyLongIntByName(AName: string): longInt;
var
  aCode: integer;
begin
  result:= 0;
  try
//    val(GetPropertyStringByName(aName), result, aCode);
   result := 0; //@rad

  except
  end
end;


procedure    TElement.SetPropertyLongIntByName(AName: string; aValue: longInt);
begin
//  SetPropertyStringByName(aName, IntToStr(aValue)) //@rad
end;


function   TElement.GetPropertyBooleanByName(AName: string): boolean;
begin
//  result:= StrToBool(GetPropertyStringByName(aName))
   result := false; // @rad
end;

procedure  TElement.SetPropertyBooleanByName(AName: string; aValue: boolean);
begin
//  SetPropertyStringByName(aName, BoolToStr(aValue)) //@rad
end;


function TElement.StoreName: boolean;
begin
   result := false;
end;

{ TNameElement }



procedure    TNameElement.Load(aReader: TReader; aIndex: TEntity);
begin
   inherited Load(aReader, aIndex);
   Name := aReader.ReadString;
end;


procedure    TNameElement.Save(aWriter: TWriter);
begin
   inherited Save(aWriter);
   aWriter.WriteString(Name);
end;



function   TNameElement.GetInstanceSize: longInt;
begin
   result:= inherited GetInstanceSize;
//  if FName <> nil then
//     result:= result + length(FName^) + 1
   if Name <> '' then result:= result + length(FName) + 1;
end;



function     TNameElement.GetName: string;
begin
//   if assigned(FName) then Result := FName^
//                      else Result := inherited GetName;
    if FName <> '' then Result := FName
                   else Result := inherited GetName;
end;

procedure    TNameElement.SetName(aName: string);
begin
   {
   if assigned(FName) then DisposeStr(FName);
   FName := nil;
   if aName <> '' then FName := NewStr(aName);
   }
   FName := aName;
end;


destructor    TNameElement.Destroy;
begin
//   if assigned(FName) then DisposeStr(FName);
   FName := '';
   inherited Destroy;
end;

function TNameElement.StoreName: boolean;
begin
   result := FName <> '';
end;

{ TOwnerElement }


destructor   TOwnerElement.Destroy;
var
   i: longInt;
begin
   if assigned(FOwners) then
   begin
      For i := FOwners.Count -1 downto 0 do
      begin
         TEntity(FOwners[i{0}]).RemoveElement(Self);
      end;
      FOwners.Free ; { !!!!!! message }
   end;
   inherited Destroy;
end;

function     TOwnerElement.GetOwnerEntity(Index: longint): TEntity;
begin
   Result := nil;
   if NoOwners or (Index >= FOwners.Count)then exit;
   Result := FOwners[Index];
end;


procedure    TOwnerElement.PutOwner(Index: longint; Item: TEntity);
begin
   if not assigned(FOwners) then FOwners := TSuperList.Create;
   if (FOwners.Count >=0) and (Index = 0) then FOwners.Add(Item)
                                          else FOwners.Insert(Index, Item);
end;


function     TOwnerElement.GetOwnersCount: longint;
begin
   if not assigned(FOwners) then Result := 0
                            else Result := FOwners.Count;
end;


procedure    TOwnerElement.AddOwner(aOwner: TEntity);
begin
   if not assigned(FOwners) then FOwners := TSuperList.Create;
   FOwners.Add(aOwner);
end;


procedure    TOwnerElement.RemoveOwner(aOwner: TEntity);
begin
   if NoOwners then exit;
   FOwners.Remove(aOwner);
end;


function     TOwnerElement.IsMyOwner(aOwner: TEntity): boolean;
begin
   Result := false;
   if not NoOwners then Result := FOwners.IndexOf(aOwner) > -1;
end;


function     TOwnerElement.NoOwners: boolean;
begin
   Result := OwnersCount = 0;
end;


function     TOwnerElement.FindOwnerClass(aClass: TClass): TEntity;
var
   i: longInt;
begin
   if not NoOwners then
   for i := 0 to OwnersCount -1 do
   begin
      if Owners[i] is aClass then
      begin
         Result := Owners[i];
         exit;
      end;
   end;
   Result := nil;
end;


function     TOwnerElement.FindOwnerName(aName: string): TEntity;
var
   i: longInt;
begin
   if not NoOwners then
   for i := 0 to OwnersCount -1 do
   begin
      if Owners[i].Name = aName then
      begin
         Result := Owners[i];
         exit;
      end;
   end;
   Result := nil;
end;



{ TEntity }



procedure    TEntity.Load(aReader: TReader; aIndex: TEntity);
begin
   inherited Load(aReader, aIndex);
   aReader.ReadListBegin;
   while not aReader.EndOfList do AddElement(aIndex.Elements[(aReader.ReadInteger)]);
   aReader.ReadListEnd;
end;


procedure TEntity.Save(aWriter: TWriter);
var
   i: longInt;
begin
   inherited Save(aWriter);
   aWriter.WriteListBegin;
   for i := 0 to Count - 1 do aWriter.WriteInteger(Elements[i].ID);
   aWriter.WriteListEnd;
end;


function TEntity.GetWholeSizes: longInt;
var
  I: longInt;
  E: TElement;
begin
  ID := BaseID;
  result:= 0;
  for I:= 0 to Count-1 do
  begin
      E := Elements[i];
      if E.ID <> BaseID then
      begin
         result:= result + E.GetWholeSizes;
      end;
  end;
  result:= result + Size
end;


function TEntity.GetWholeCount: longInt;
//var
//  I: longInt;
//  E: TElement;
begin
   ResetBaseID;
   result := GetWholeCounts;
end;


function TEntity.GetWholeCounts: longInt;
var
  I: longInt;
  E: TElement;
begin
   ID := BaseID;
   result:= 0;
   for I:= 0 to Count-1 do
   begin
       E := Elements[i];
       if E.ID <> BaseID then
       begin
          if E is TEntity then
             result:= result + TEntity(E).GetWholeCounts
          else
             E.ID := BaseID;
       end;
   end;
   result:= result + Count;
end;



function TEntity.ElementsCount: longInt;
begin
  result:= 0;
  try
    if assigned(FElements) then
       Result:= FElements.Count
    else
      FElements:= TSuperList.Create;
  except
  end
end;


function TEntity.GetLastIndex: longInt;
begin
   result := Count - 1;
end;



function TEntity.Get(Index: longInt): TElement;
begin
  if assigned(FElements) then
     Result:= FElements.Items[Index]
  else
  begin
    FElements:= TSuperList.Create;
    Result:= nil
  end
end;

procedure TEntity.Put(Index: longint; Item: TElement);
begin
  if not assigned(FElements) then FElements:= TSuperList.Create;
  if (FElements.Count <= 0) and (Index = 0) then FElements.Add(Item)
                                            else FElements.Items[Index]:= Item;
end;


function     TEntity.GetElement(aName: string): TElement;
var
   A: TAliases;
begin
   result := nil;
   A := TAliases(FindElementClass(TAliases));
   if A <> nil then
   begin
      result := A.Alias[aName];
   end;
   if result = nil then
   begin
      result := FindElementName(aName);
   end;
end;

procedure    TEntity.SetElement(aName: string; aElement: TElement);
var
   A: TAliases;
   E: TElement;
begin
   A := TAliases(FindElementClass(TAliases));
   if A = nil then
   begin
      A := TAliases.Create;
      AddElement(A);
   end;
   E := A.Alias[aName];
   if E <> nil then FreeElement(E);
   A.Alias[aName]:= aElement;
   AddElement(aElement);
end;




destructor  TEntity.Destroy;
begin
   FreeAll;
   if assigned(FElements) then FElements.Free;
   inherited Destroy;
end;


function    TEntity.CreateEnvelope: TElement;
var
   i: longInt;
   Element: TElement;
begin
   result := inherited CreateEnvelope;
   for i := 0 to Count -1 do
   begin
      Element := Elements[i];
      if Element.NoOwners then TEntity(result).AddElement(Element.CreateEnvelope)
                          else TEntity(result).AddElement(Element);
   end;
end;



function     TEntity.IndexOf(aElement: TElement): longInt;
begin
   if assigned(FElements) then result := FElements.IndexOf(aElement)
                          else result := -1;
end;

{

function     TEntity.FirstThat(Fn: TE_Function): TElement;
begin
   Result := FElements.FirstThat(Fn);
end;


procedure    TEntity.ForEach(Proc: TE_Procedure);
begin
   FElements.ForEach(TSL_Procedure(Proc));
end;

}

procedure   TEntity.FastFreeAll;
//var i: longInt;
begin
   if Assigned(FElements) then
   begin
      FElements.FastFreeAll;
      FElements.Clear;
   end
end;

{!!!}
procedure CheckTestedElement;
var
   aOwner: TEntity;
   S: string;
begin
   if TestedElement = nil then exit;
   if TestedElement.OwnersCount > 0 then
   begin
      try
         aOwner := TestedElement.Owners[0];
         S := aOwner.Name;
      except
         ShowMessage('Test ... chyba !!!');
      end;
   end;
end;

procedure   TEntity.FreeAll;
var
  i, aCount: longInt;
  Element: Telement;
  //TheCursor: TCursor;
begin
  if NoElements then exit;
  //TheCursor:= Screen.Cursor;
  //Screen.Cursor:= crHourGlass;
  try
   aCount:=  Count;
   if aCount > 200 then
      Application.ProcessMessages;
   for i := aCount-1 downTo 0 do
   begin
      Element := TElement(Elements[i]);
      if Element <> nil then
      begin
        if Element.IsPossibleToFree then
        begin
           {!}{ Deletovat element je asi zbyten, kdy se stejn vol FElements.clear}
           //FElements.Delete(I);
           // Tak tohle zpomalovalo ruen a k nepetnosti (kdy to tam nebylo):
           Element.RemoveOwner(Self);  ///!!!!!!!!!
           Element.Free;
           //{!!!}CheckTestedElement;
{           FreeElement(Element); }
        end
        else
        begin
           Element.RemoveOwner(Self);
        end
      end
   end;
   FElements.Clear;
  except
   on E:Exception do
   begin { Dialogs, Controls }
      ShowMessage(name+' TEntity.FreeAll' + #13 + #10 +
                   E.Message);
   end
  end;
  //Screen.Cursor:= TheCursor;
end;



procedure   TEntity.HardFreeAll;
var
   i, aCount: longInt;
   Element: Telement;
begin
  try
   if NoElements then exit;
   aCount:=  Count;

   if aCount > 200 then
      Application.ProcessMessages;

   for i := aCount-1 downTo 0 do
   begin
      Element := TElement(Elements[i]);
      if Element <> nil then
      begin
      try
        //FElements.Delete(I); {!}
        Element.RemoveOwner(Self);
        Element.Free;
      except
      end
      end
   end;
   FElements.Clear;
  except
   on E:Exception do
   begin { Dialogs, Controls }
      ShowMessage('TEntity.HardFreeAll' + #13 + #10 +
                   E.Message);
      //Screen.Cursor:= crDefault;
   end
  end
end;



procedure   TEntity.Clear;
//var
//  I: longInt;
//  aEl: TElement;
begin
   if NoElements then exit;
{!}
{ O.S. 98.01.04 ! dleit, doposud zmizel vlastnk avak odkaz na nj zstal }
{ Jene se to len zpomal krom toho Clear neslou k njak obsluze vlastnk,
  proto celou tuhle zmnu hzm do koe .... pt takovhle brejkule konzultovat
  s vedoucm projekt .... Pedem !!!!!!!!!!!!!}
  (*
   for I:= 0 to Count-1 do
   begin
     aEl:= Elements[I];
     aEl.RemoveOwner(self);
   end;
  *)
{ konec pravy }

   FElements.Clear;
end;


procedure   TEntity.PAddAllFrom(aEl: TElement);
var
  I: longInt;
begin
  if not (aEl is TEntity) then exit;
  for I:= 0 to TEntity(aEl).Count-1 do
  begin
    AddElement(TEntity(aEl).Elements[I])
  end;
end;


{ !!!!!! chyb informace o tom, zda uloit entitu do seznamu vlastnk }
{ zatm se ukld automaticky }
{ !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! }

function   TEntity.CreateElement(const aClass, aName: string): TElement;
var
   C: TElementClass;
   E: TElement;
begin
   result := nil;
   C := nil; // @xe5
//   C := TElementClass(GetOrbisClass(aClass)); @xe5
   if C = nil then exit;
   E := C.Create;
   E.Name := aName;
   result := E;
   AddElement(E);
end;


procedure   TEntity.AddElement(aElement: TElement);
begin
   if not assigned(aElement) then exit;
   if not assigned(FElements) then
      FElements:= TSuperList.Create;
   aElement.AddOwner(Self);
   FElements.Add(aElement);
end;

procedure   TEntity.InsertElement(aIndex: longInt; aElement: TElement);
begin
   if not assigned(aElement) then exit;
   if not assigned(FElements) then
   begin
      if aIndex = 0 then
      begin
         FElements:= TSuperList.Create;
         FElements.Add(aElement);
      end
      else exit;
   end
   else
   begin
      FElements.Insert(aIndex, aElement);
   end;
   aElement.AddOwner(Self);
end;


procedure   TEntity.RemoveElement(aElement: TElement);
begin
  if aElement = nil then exit;
  if assigned(FElements) then
  begin
     try
        aElement.RemoveOwner(Self);
     except
//{$IFDEF MSWINDOWS}
//        MessageBeep(word(-1));
//{$ENDIF}
     end;
     FElements.Remove(aElement);
  end;
end;

procedure TEntity.RemoveElementIndex(aIndex: integer);
var
   aElement: TElement;
begin
   if not assigned(FElements) then exit;
   if (aIndex < 0) or (aIndex >= FElements.Count) then exit;
   aElement := FElements.Items[aIndex];
   try
      aElement.RemoveOwner(Self);
   except
//{$IFDEF MSWINDOWS}
//        MessageBeep(word(-1));
//{$ENDIF}
   end;
   FElements.Delete(aIndex);
end;

procedure   TEntity.FreeElement(aElement: TElement);
begin
  if aElement = nil then exit;
  if assigned(FElements) then
  begin
    try
      FElements.Remove(aElement);
      if aElement.IsPossibleToFree then
         TElement(aElement).Free
      else
         aElement.RemoveOwner(Self);
    except
     on E:Exception do
     begin { Dialogs, Controls }
        ShowMessage('TEntity.FreeElement' + #13 + #10 +
                     E.Message);
        //Screen.Cursor:= crDefault;
     end
    end
  end
end;

procedure TEntity.FreeElementIndex(aIndex: integer);
var
   aElement: TElement;
begin
   if not assigned(FElements) then exit;
   if (aIndex < 0) or (aIndex >= FElements.Count) then exit;
   aElement := FElements.Items[aIndex];
   try
      FElements.Delete(aIndex);
      if aElement.IsPossibleToFree then
         TElement(aElement).Free
      else
         aElement.RemoveOwner(Self);
    except
     on E:Exception do
     begin { Dialogs, Controls }
        ShowMessage('TEntity.FreeElement' + #13 + #10 +
                     E.Message);
        //Screen.Cursor:= crDefault;
     end
    end
end;


procedure    TEntity.ExchangeElements(Element1, Element2: TElement);
var
  I1, I2: longInt;
begin
  I1:= FElements.IndexOf(Element1);
  I2:= FElements.IndexOf(Element2);
  FElements.Exchange(I1, I2)
end;

procedure TEntity.ExchangeElementsIndex(aIndex1, aIndex2: integer);
begin
   if FElements <> nil then
      FElements.Exchange(aIndex1, aIndex2);
end;


function    TEntity.NoElements: boolean;
begin
   Result := (FElements =  nil) or (FElements.Count <= 0);
end;

function     TEntity.FindElementClass(aClass: TClass): TElement;
var
   i: longInt;
begin
   if not NoElements then
   for i := 0 to Count -1 do
   begin
      if Elements[i] is aClass then
      begin
         Result := Elements[i];
         exit;
      end;
   end;
   Result := nil;
end;



function     TEntity.FindElementName(aName: string): TElement;
var
   i: longInt;
   Jm: string;
begin
  aName:= ANSIUpperCase(aName);
   if not NoElements then
   for i := 0 to Count -1 do
   begin
      Jm:= ANSIUpperCase(Elements[i].Name);
      if Jm = aName then
      begin
         Result := Elements[i];
         exit;
      end;
   end;
   Result := nil;
end;




function     TEntity.CanFreeElement(aElement: TElement): boolean;
begin
   result := false;
end;






procedure   TEntity.HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean);
var
   i: longInt;
begin
   exit; {!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}
   if NoElements then Exit;
   for i := 0 to Count -1 do
   begin
      Elements[i].HandleMessage(aMessage, Handled);
      if Handled then break;
   end;
end;


procedure   TEntity.OnTimer;
var
   i : word;
begin
   for i := 0 to FElements.Count-1 do
   begin
      TElement(FElements.Items[i]).OnTimer;
   end;
end;



procedure  TEntity.GetElements(aEntity: TEntity; aFrom, aTo: longInt);
var
  I: longInt;
begin
  for I:= aFrom to aTo do
  begin
    AddElement(aEntity.Elements[I])
  end
end;

function  TEntity.GetClassCount(aClass: TElementClass): longInt;
var
  I: longInt;
begin
  result:= 0;
  for I:= 0 to count-1 do
  begin
    if Elements[I] is aClass then
       result:= result + 1
  end
end;



procedure   TEntity.ResetIDs;
var
   i: longInt;
   E: TElement;
begin
   inherited ResetIDs;
   if NoElements then exit;
   for i := 0 to Count -1 do
   begin
      E := Elements[i];
      if E.ID <> BaseID then E.ResetIDs;
   end;
end;

function TEntity.FindOrCreateElementName(const aClass: TElementClass;
  const aName: string): TElement;
begin
   result := FindElementName(aName);
   if result = nil then
   begin
      result := aClass.Create;
      result.Name := aName;
      AddElement(result);
   end;
end;

procedure TEntity.ExchangeFieldElement(var aField: TElement;
          const aElement: TElement);
var
   JustExists: boolean;
begin
   JustExists := false;
   if aField <> nil then
   begin
      FreeElement(aField);
      aField := nil;
   end
   else
      JustExists := IndexOf(aElement) >= 0;
   aField := aElement;
   if not JustExists then
      AddElement(aElement);
end;

procedure TEntity.SetElementToFree(const Value: TElement);
begin
   FreeElement(Value);
end;



procedure TEntity.RAddAllFrom(aEl: TElement);
var
  I: integer;
begin
  if not (aEl is TEntity) then exit;
  for I:= TEntity(aEl).Count-1 downto 0 do
  begin
    AddElement(TEntity(aEl).Elements[I])
  end;
end;

{ TAliases }

function  TAliases.GetAlias(aName: string): TElement;
var
   A: TElement;
begin
   result := nil;
   A := FindElementName(aName);
   if not (A is TAliasElement) then exit;
   if not Assigned(A) then exit;
   result := TAliasElement(A).Element;
end;

procedure TAliases.SetAlias(aName: string; aElement: TElement);
var
   A: TAliasElement;
begin
   if aElement = nil then exit;
   A := TAliasElement(FindElementName(aName));
   if A = nil then
   begin
      A := TAliasElement.Create;
      A.Name := aName;
      AddElement(A);
   end;
   A.Element := aElement;
end;




{ TQuickEntity }

procedure  TQuickEntity.AddElement(aElement: TElement);
begin
   if not assigned(aElement) then exit;
   if not assigned(FElements) then
      FElements:= TSuperList.Create;
   FElements.Add(aElement);
end;

procedure  TQuickEntity.InsertElement(aIndex: longInt; aElement: TElement);
begin
   if not assigned(aElement) then exit;
   if not assigned(FElements) then
   begin
      if aIndex = 0 then
      begin
         FElements:= TSuperList.Create;
         FElements.Add(aElement);
      end
      else exit;
   end
   else
   begin
      FElements.Insert(aIndex, aElement);
   end;
end;


procedure TQuickEntity.SetClearIt(const Value: boolean);
begin
   if Value then
      Clear;
end;

{ TEnvelopeEntity }


procedure  TEnvelopeEntity.SetOwner(aOwner: TEntity);
begin
   {
   if FOwner <> nil then RemoveOwners;
   }
   FOwner := aOwner;
   {
   AddOwners;
   }
end;

{
procedure  TEnvelopeEntity.AddOwners;
var
   i: longInt;
begin
   for i := 0 to Count -1 do Elements[i].AddOwner(FOwner);
end;

procedure  TEnvelopeEntity.RemoveOwners;
var
   i: longInt;
begin
   for i := 0 to Count -1 do Elements[i].RemoveOwner(FOwner);
end;

procedure   TEnvelopeEntity.AddElement(aElement: TElement);
begin
   if not assigned(aElement) then exit;
   if not assigned(FElements) then
      FElements:= TSuperList.Create;
   aElement.AddOwner(Owner);
   FElements.Add(aElement);
end;

procedure   TEnvelopeEntity.InsertElement(aIndex: longInt; aElement: TElement);
begin
   if not assigned(aElement) then exit;
   if not assigned(FElements) then
   begin
      if aIndex = 0 then
      begin
         FElements:= TSuperList.Create;
         FElements.Add(aElement);
      end
      else exit;
   end
   else
   begin
      FElements.Insert(aIndex, aElement);
   end;
   aElement.AddOwner(Owner);
end;


procedure   TEnvelopeEntity.RemoveElement(aElement: TElement);
begin
  if assigned(FElements) then
  begin
     aElement.RemoveOwner(Owner);
     FElements.Remove(aElement);
  end;
end;
}

procedure  TEnvelopeEntity.AddOwner(aOwner: TEntity);
begin
   Owner := aOwner;
end;

procedure    TEnvelopeEntity.HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean);
begin
   aMessage.Receiver := Owner;
   Owner.HandleMessage(aMessage, Handled);
end;



function TEnvelopeEntity.FindClassInOwners(aClass: TClass): TEntity;
begin
   Result := nil;
   if Self is aClass then
   begin
      result := TEntity(Self);
      exit;
   end;
   if Owner = nil then exit;
   result := Owner.FindClassInOwners(aClass);
end;

function  TEnvelopeEntity.FindClassWithOwnerInOwners(aClass: TClass; aOwner: TEntity): TEntity;
begin
   Result := nil;
   if Self is aClass then
   begin
      if IsMyOwner(aOwner) then
         result := TEntity(Self);
      exit;
   end;
   if Owner = nil then exit;
   result := Owner.FindClassWithOwnerInOwners(aClass,aOwner);
end;

function  TEnvelopeEntity.FindFirstClassWithOwnerInOwners(aClass: TClass; aOwner: TEntity): TEntity;
begin
   Result := nil;
   if Self is aClass then
   begin
      if IsMyOwner(aOwner) then
         result := TEntity(Self);
      exit;
   end;
   if Owner = nil then exit;
   result := Owner.FindFirstClassWithOwnerInOwners(aClass,aOwner);
end;

function TEnvelopeEntity.FindOwnerClass(aClass: TClass): TEntity;
begin
   Result := nil;
   if Self is aClass then
   begin
      result := TEntity(Self);
      exit;
   end;
   if Owner = nil then exit;
   if Owner is aClass then result := Owner;
end;

{ TNameEntity }

procedure    TNameEntity.Load(aReader: TReader; aIndex: TEntity);
begin
   inherited Load(aReader, aIndex);
   Name := aReader.ReadString;
end;


procedure     TNameEntity.Save(aWriter: TWriter);
begin
   inherited Save(aWriter);
   aWriter.WriteString(Name);
end;



function   TNameEntity.GetInstanceSize: longInt;
begin
   result:= inherited GetInstanceSize;
//  if FName <> nil then
//     result:= result + length(FName^) + 1
   if FName <> '' then result := result + length(FName) + 1;
end;



function     TNameEntity.GetName: string;
begin
//   if assigned(FName) then Result := FName^
//                      else Result := inherited GetName;
   if FName <> '' then result := FName
                  else result := inherited GetName;
end;

procedure    TNameEntity.SetName(aName: string);
begin
//   if assigned(FName) then DisposeStr(FName);
//   FName := nil;
//   if aName <> '' then FName := NewStr(aName);
   FName := aName;
end;


destructor    TNameEntity.Destroy;
begin
//   if assigned(FName) then DisposeStr(FName);
   FName := '';
   inherited Destroy;
end;


function TNameEntity.StoreName: boolean;
begin
   result := FName <> '';
end;

{ TOwnerEntity }

destructor   TOwnerEntity.Destroy;
var
   i: longInt;
   aOwner: TElement;

begin
   aOwner := nil;
   if assigned(FOwners) then
   begin
     try
      For i := FOwners.Count -1 downto 0 do
        begin
        aOwner:= FOwners[i];

        try
          if not(aOwner is TEntity) then
          begin
            ShowMessage('TOwnerEntity.Destroy: patn vlastnk');
            continue;
          end
        except
          ShowMessage('TOwnerEntity.Destroy: chybn vlastnk objektu ' + Name + ' .' + intToStr(I));
        end;

        if TEntity(aOwner).Count > 0 then { v pripade ze toto neni posledni element }
           TEntity(aOwner).RemoveElement(Self);
      end;
     except
       ShowMessage('TOwnerEntity.Destroy: chyba cyklu uvolovn , '
                    + aOwner.ClassName + ' : ' + aOwner.Name);
     end;

     FOwners.Free ; { !!!!!! message }
   end;
   inherited Destroy;
end;

function     TOwnerEntity.GetOwnerEntity(Index: longint): TEntity;
begin
   Result := nil;
   if NoOwners or (Index >= FOwners.Count)then exit;
   Result := FOwners[Index];
   {!}
   try
     if result = nil then
     begin
       ShowMessage('TOwnerEntity('+Name+').GetOwner: Objekt vlastnka je przdn');
       exit
     end;
     if not (TElement(result) is TEntity) then
     begin
       ShowMessage('TOwnerEntity('+Name+').GetOwner: Objekt vlastnka nen TEntity');
       result:= nil;
       exit
     end
   except
     ShowMessage('TOwnerEntity('+Name+').GetOwner: Chybn objekt vlastnka');
     result:= nil
   end
  {!!}
end;


procedure    TOwnerEntity.PutOwner(Index: longint; Item: TEntity);
begin
   if not assigned(FOwners) then FOwners := TSuperList.Create;
   if (FOwners.Count >=0) and (Index = 0) then FOwners.Add(Item)
                                          else FOwners.Insert(Index, Item);
end;


function     TOwnerEntity.GetOwnersCount: longint;
begin
   if not assigned(FOwners) then Result := 0
                            else Result := FOwners.Count;
end;


procedure    TOwnerEntity.AddOwner(aOwner: TEntity);
begin
   if not assigned(FOwners) then FOwners := TSuperList.Create;
   FOwners.Add(aOwner);
end;


procedure    TOwnerEntity.RemoveOwner(aOwner: TEntity);
begin
   if NoOwners then exit;
   FOwners.Remove(aOwner);
end;

function     TOwnerEntity.IsMyOwner(aOwner: TEntity): boolean;
begin
   Result := false;
   if not NoOwners then Result := FOwners.IndexOf(aOwner) > -1;
end;


function     TOwnerEntity.NoOwners: boolean;
begin
   Result := OwnersCount = 0;
end;


function     TOwnerEntity.FindOwnerClass(aClass: TClass): TEntity;
var
   i: longInt;
   aOwner: TEntity;
begin
   Result:= nil;

   if not NoOwners then
   for i := 0 to OwnersCount -1 do
   begin
      aOwner := Owners[i];
      if aOwner is TEnvelopeEntity then aOwner := TEnvelopeEntity(aOwner).Owner;
      if aOwner is aClass then
      begin
         Result := aOwner;
         exit;
      end;
   end
   else
     Result := nil;
end;


function     TOwnerEntity.FindOwnerName(aName: string): TEntity;
var
   i: longInt;
   aOwner: TEntity;
begin
   Result:= nil;

   if not NoOwners then
   for i := 0 to OwnersCount -1 do
   begin
      aOwner := Owners[i];
      if aOwner is TEnvelopeEntity then aOwner := TEnvelopeEntity(aOwner).Owner;
      if aOwner.Name = aName then
      begin
         Result := aOwner;
         exit;
      end;
   end
   else
     Result := nil;
end;

procedure TOwnerEntity.InsertNameSortedEntity(Entity: TNameEntity);
var
  Nasel: boolean;
  I: longInt;
begin
  if Count > 0 then
  begin
    if TNameEntity(Elements[Count-1]).Name <= Entity.Name then
       AddElement(Entity)
    else
    begin
      Nasel:= false;
      I:= 0;
      while not Nasel and (I<Count) do
      begin
        if TNameEntity(Elements[I]).Name > Entity.Name then
        begin
          InsertElement(I, Entity);
          Nasel:= true
        end
        else
          inc(I)
      end;
      if not Nasel then
         AddElement(Entity)
    end
  end
  else
    AddElement(Entity)
end;




function TOwnerEntity.CreateSubEntity
         (aClass: TElementClass; aName: string): TNameEntity;
begin
  if aName = '' then aName:= 'no name';
  Result:= TNameEntity(FindElementName(aName));
  if Result = nil then
  begin
    Result:= TNameEntity(aClass.Create);
    if Result <> nil then
    begin
      Result.Name:= aName;
      InsertNameSortedEntity(Result);
    end;
  end
end;





INITIALIZATION
//   RegisterOrbisClass(TElement);
//   RegisterOrbisClass(TNameElement);
//   RegisterOrbisClass(TOwnerElement);
//   RegisterOrbisClass(TEntity);
//   RegisterOrbisClass(TNameEntity);
//   RegisterOrbisClass(TOwnerEntity);
//   RegisterOrbisClass(TEnvelopeEntity);
//   RegisterOrbisClass(TQuickEntity);
//   RegisterOrbisClass(TOrbisMessage);
END.
